import 'dart:async';
import 'package:sqflite/sqflite.dart';
import 'm7db.dart';

main1()async{

Database _database;

UserDao userDao = UserDao(_database, 'User');

User user = User(id: 1,name: "Abood",email: "a3bd2llah@gmail.com",isOnline: false);

userDao.insert(user);

userDao.delete(user);

userDao.update(user);

userDao.insertAll([user]);

userDao.getById(user.id);

userDao.getAll();

// return a stream to listen to it represent the whole table in data base
userDao.watchAll().listen((event) {'your event here';});

}

class AppDB extends M7DB{

// here u passed the database Name
AppDB(String databaseName) : super(databaseName);


// create your tables
  @override
  FutureOr<void> onCreate(Database db, int version) async{
  // execute tables creation
  await db.execute("CREATE TABLE TABLE1 (id INTEGER AUTOINCREMENT PRIMARY KEY)");
  await db.execute("CREATE TABLE TABLE2 (id INTEGER AUTOINCREMENT PRIMARY KEY)");
}

}

class User extends M7Table{

int id;
String name;
String email;
bool isOnline;


// this will be used in Dao
@override
get primaryKey => id;


// constructor with out parameters
User({this.id,this.name,this.email,this.isOnline}):super.create();


User.fromMap(Map map) : super.fromMap(map){
id = map['id'];
name = map['name'];
email = map['email'];
/// [intToBoolean] is a helper function to deal with boolean type in data base beyond u
isOnline = intToBoolean(map['isOnline']);
}

// this will be used in Dao
// real represent of how your data will be saved into DataBase
@override
Map<String, dynamic> toMap() {
return{
"id":this.id,
"name":this.name,
"email":this.email,

/// [booleanToInt] is a helper function to deal with boolean type in data base beyond u
"isOnline":booleanToInt(this.isOnline)
};
}

// optional but helps you if u implemented in your app to copy a fast copy of the existing object
@override
M7Table copyWith({int newId,String newName,String newEmail,bool newIsOnline}) {
return User(id:  newId ?? this.id,name: newName ?? this.name,email: newEmail ?? this.email,isOnline: newIsOnline ?? this.isOnline);
}

}

class UserDao extends M7Dao<User>{

UserDao(Database database, String tableName) : super(database, tableName);

@override
User fromDB(Object map) =>User.fromMap(map);
}

main()async{

Database _database;

UserDao userDao = UserDao(_database, 'User');

User user = User(id: 1,name: "Abood",email: "a3bd2llah@gmail.com",isOnline: false);

userDao.insert(user);

userDao.delete(user);

userDao.update(user);

userDao.insertAll([user]);

userDao.getById(1);

userDao.getAll();

userDao.watchAll().listen((event) {'your event here';});

StreamController streamController;

userDao.watch(streamController, () async=>await userDao.database.query('table'));

userDao.notifyListener();


}

//```